


extern void 		lcd_4bus_write(uint8_t data);//   4  ,   RS=RW=0,  DB3..0 = 0    Z   
extern uint8_t 	lcd_read_byte(void);//   4  //  .  PORTLCD 4    //  , RS=RW=0,  DB3..0 = 0    Z    
extern uint8_t 	read_busy_address(void);
extern void 		lcd_write_data(uint8_t data);//write data to CGRAM or DDRAM
extern uint8_t 	lcd_read_data(void);//read data from CGRAM or DDRAM
extern void 		lcd_instructions_set(uint8_t address);
extern void 		lcd_init(void);
extern void		lcd_set_address(uint8_t x);

void sig_E(void);// strob
void function_set_8bit(void);//   . lcd_init()

extern void main2(void);

//      lcd; 7,    (--).
#define PORTLCD PORTB
#define DDRLCD	DDRB
#define PINLCD	PINB



#define E	_BV(6)
#define RW	_BV(5)
#define RS	_BV(4)
#define DB7	_BV(3)
#define DB6	_BV(2)
#define DB5	_BV(1)
#define DB4	_BV(0)
#define DB3	_BV(3)
#define DB2	_BV(2)
#define DB1	_BV(1)
#define DB0	_BV(0)


//  lcd  !    
#define busy_flag					0x80
#define clear_display				0x01 //1.5mS  .       
#define return_home					0x02 //40uS     
//---------Entry mode set--------------- //40uS        
#define	inc_AC						0x06
//#define inc_AC_display_shift_richt	0x05
#define dec_AC						0x04
//#define dec_AC_display_shift_left	0x07
//---------Display control--------------
#define display_off					0x08
#define display_on					0x0C
#define cursor_off					0x0C		
#define cursor_lines				0x0E
#define cursor_lin_blinks			0x0F 
#define cursor_blinks				0x0D 
//---------Cursor/display shift---------
#define shift_cursor_left			0x10
#define shift_cursor_richt			0x14
#define shift_display_left			0x18
#define shift_display_richt			0x1C
//--------------Function set------------
//--------------------------------------

#define set_cgram_address				0x40 //max 63
#define set_ddram_address				0x80 //max 127


/* 9.     IR
RS	RW	D7	D6	D5	D4	D3	D2	D1	D0	
--------------------------------------------------------------------------------------------------------------------- 
0	0 |	0 	0	0	0	0	0	0	1	 ,  = 0,    DDRAM			//Clear display  
0	0 |	0	0	0	0	0	0	1	-	 = 0,   DDRAM,  ,      DDRAM //Return Home
0	0 |	0	0	0	0	0	1	I/D	S 	      		//Entry mode set
0	0 |	0	0	0	0	1	D	C	B	  							//Display control
0	0 |	0	0	0	1	S/C	R/L	-	-	  /							//Cursor/display shift  
0	0 |	0	0	1	DL	N	F	-	-	       	//Function set
0	0 |	0	1	AG	AG	AG	AG	AG	AG	      CGRAM 			//Set CGRAM address
0	0 |	1	AD	AD	AD	AD	AD	AD	AD	      DDRAM			//Set DDRAM address
0	1 |	BF			AC					Read busy flag and address
1	1 |			Read data				Reads data from CGRAM or DDRAM.
1	0 |			Write data				Writes data to CGRAM or DDRAM.
---------------------------------------------------------------------------------------------------------------------  
*/
/*
 7. ,    HD44780
--------------------------------------------------------------------------------------------------------------------- 
I/D:	    , 0 - , 1 - .
---------------------------------------------------------------------------------------------------------------------  
S:		    . 0 -    , 
		1 -    DDRAM      , 
		  I/D: 0 - , 1 - .    
		  DDRAM.     
		    DDRAM.
---------------------------------------------------------------------------------------------------------------------  
S/C:	-,     R/L     
		( ,     ,    DDRAM)  . 
		 : 0 -  , 1 -  . 
--------------------------------------------------------------------------------------------------------------------- 
R/L:	-,     S/C     . 
		  : 0 - , 1 - . 
--------------------------------------------------------------------------------------------------------------------- 
D/L:	,    : 0 - 4 , 1 - 8 . 
--------------------------------------------------------------------------------------------------------------------- 
N:		    : 0 -  , 1 -   
--------------------------------------------------------------------------------------------------------------------- 
F:		  : 0 - 5  8 , 1 - 5  10 . 
--------------------------------------------------------------------------------------------------------------------- 
D:		 : 0 - , 1 -  
--------------------------------------------------------------------------------------------------------------------- 
:		   : 0 - , 1 -  
--------------------------------------------------------------------------------------------------------------------- 
:		    : 0 - , 1 - . 
--------------------------------------------------------------------------------------------------------------------- 
*/

/*
     = 0,  R/W = 0,   RS - ,
  DBO...DB7     (I). 
    (E  R/W)      
     -
*/
/*
  (DR),   (IR),  (DDRAM),   (CGRAM), 
   (),   .
 RS = 0 -    (IR),  RS = 1 -   (DR).
R/W = 1 - ; R/W = 0 -  

 (DDRAM) - 2   40 
*/
/*
 1.    8-  
	   RS 
	       DB0...DB7 
	   = 1 
	  E = 0 
	   DB0...DB7 = HI 
 2.    8-  
	   RS 
	  R/W = 1 
	   = 1 
	       DB0...DB7 
	   = 0 
	  R/W = 0 
//-----------------------------------------------------------------------

 3.    4-  
	   RS 
	         DB4...DB7 
	   = 1 
	   = 0 
	         DB4...DB7 
	   = 1 
	   = 0 
	   DB4...DB7 = HI 
 4.    4-  
	   RS 
	  R/W = 1 
	   = 1 
	         DB4...DB7 
	   = 0 
	   = 1 
	         DB4...DB7 
	   = 0 
	  R/W = 0 
*/

